function BunnyhopinfoExtrema(bunnyhopinfo)
{
  this.bunnyhopinfo=bunnyhopinfo;
  this.bunnyhop=this.bunnyhopinfo.bunnyhop;
  this.minima=this.bunnyhopinfo.minima;
  this.maxima=this.bunnyhopinfo.maxima;
  this.bunnyhopinfo.ergebnisfeld("min_y",this.bunnyhopinfo.nice_real(this.minima.f,1000,3));
  this.bunnyhopinfo.ergebnisfeld("max_y",this.bunnyhopinfo.nice_real(this.maxima.f,1000,3));
  this.bunnyhopinfo.ergebnisfeld("min_y_",this.bunnyhopinfo.nice_real(this.minima.f_,100000,5));
  this.bunnyhopinfo.ergebnisfeld("max_y_",this.bunnyhopinfo.nice_real(this.maxima.f_,100000,5));
  this.bunnyhopinfo.ergebnisfeld("min_y__",this.bunnyhopinfo.nice_real(this.minima.f__,10000000,7));
  this.bunnyhopinfo.ergebnisfeld("max_y__",this.bunnyhopinfo.nice_real(this.maxima.f__,10000000,7));
  this.bunnyhopinfo.ergebnisfeld("min_dl",this.bunnyhopinfo.nice_real(this.minima.dl,1000000,6));
  this.bunnyhopinfo.ergebnisfeld("max_dl",this.bunnyhopinfo.nice_real(this.maxima.dl,1000000,6));
}

function bunnyhopinfo_extrema()
{
  this._extrema=new BunnyhopinfoExtrema(this);
}

function BunnyhopinfoFormeln(bunnyhopinfo)
{
  this.bunnyhopinfo=bunnyhopinfo;
  this.bunnyhop=this.bunnyhopinfo.bunnyhop;
  this.bunnyhopinfo.ergebnisfeld("line_ll_a",this.bunnyhop.yplus);
  this.bunnyhopinfo.ergebnisfeld("line_ll_max_x",this.bunnyhop.cos_left.min_x-this.bunnyhop.xplus);
  this.bunnyhop.cos_left.out();
  this.bunnyhop.line_left.out();
  this.bunnyhop.cos_middle.out();
  this.bunnyhop.line_right.out();
  this.bunnyhop.cos_right.out();
  this.bunnyhopinfo.ergebnisfeld("line_rr_a",this.bunnyhop.yplus);
  this.bunnyhopinfo.ergebnisfeld("line_rr_min_x",this.bunnyhop.cos_right.max_x-this.bunnyhop.xplus);
  this.minima=this.bunnyhopinfo.minima;
  this.maxima=this.bunnyhopinfo.maxima;
  this.bunnyhopinfo.ergebnisfeld("min_r_kuppe",this.bunnyhopinfo.nice_real(-1.0/this.minima.f__,1000,3));
  this.bunnyhopinfo.ergebnisfeld("min_r_wanne",this.bunnyhopinfo.nice_real(1.0/this.maxima.f__,1000,3));
}

function bunnyhopinfo_formeln()
{
  this._formeln=new BunnyhopinfoFormeln(this);
}

function bunnyhopinfo_tabelle_kopf()
{
  var rtr=document.createElement("tr");
  this.rtbody.appendChild(rtr);
  var rth=new Array();
  for(var i=0;i<0x6;i++)
  {
    rth[i]=document.createElement("th");
    rtr.appendChild(rth[i]);
  }
  rth[0x0].innerHTML="x<br />[m]";
  rth[0x1].innerHTML="&nbsp;";
  rth[0x2].innerHTML="f(x)<br />[m]";
  rth[0x3].innerHTML="f'(x)<br />[1]";
  rth[0x4].innerHTML="f''(x)<br />[m<sup>-1</sup>]";
  rth[0x5].innerHTML="dl(x)<br />[1]";
}

function bunnyhopinfo_tabelle_zeile(values)
{
  var rtr=document.createElement("tr");
  this.rtbody.appendChild(rtr);
  var rtd=new Array();
  for(var i=0;i<0x6;i++)
  {
    var cname="td";
    rtd[i]=document.createElement("td");
    rtr.appendChild(rtd[i]);
    switch(this.t%5)
    {
    case 0x1:
    case 0x4:
      cname+="u";
      break;
    default:
      cname+="x";
    }
    switch(i)
    {
    case 0x0:
      cname+="0";
      break;
    default:
      cname+="r";
    }
    rtd[i].setAttribute("class",cname);
  }

  rtd[0x0].innerHTML=""+this.nice_real(values.x,1000,3);
  rtd[0x0].style.backgroundColor=this.colors[this.point];

  rtd[0x1].innerHTML="&nbsp;";
  if (Math.round(Math.abs(values.x))%1000==0)
    {rtd[0x1].style.backgroundColor="#777777";}
  else
    {rtd[0x1].style.backgroundColor=this.colors[this.point];}

  rtd[0x2].innerHTML=""+this.nice_real(values.f,1000,3);
  rtd[0x2].style.backgroundColor="rgb("+Math.round((64*(values.f-this.minima.f)/(this.maxima.f-this.minima.f))+191)+",255,"+Math.round((64*(values.f-this.minima.f)/(this.minima.f-this.maxima.f))+255)+")";

  rtd[0x3].innerHTML=""+this.nice_real(values.f_,1000000,6);
  rtd[0x3].style.backgroundColor="rgb(208,"+Math.round((64*(values.f_-this.minima.f_)/(this.maxima.f_-this.minima.f_))+191)+","+Math.round((64*(values.f_-this.minima.f_)/(this.minima.f_-this.maxima.f_))+255)+")";

  rtd[0x4].innerHTML=""+this.nice_real(values.f__,1000000000,9);
  rtd[0x4].style.backgroundColor="rgb("+Math.round((64*(values.f__-this.minima.f__)/(this.minima.f__-this.maxima.f__))+255)+",208,"+Math.round((64*(values.f__-this.minima.f__)/(this.maxima.f__-this.minima.f__))+191)+")";

  rtd[0x5].innerHTML=""+this.nice_real(values.dl,1000000,6);
  rtd[0x5].style.backgroundColor="rgb(208,"+Math.round((64*(values.dl-this.minima.dl)/(this.minima.dl-this.maxima.dl))+255)+","+Math.round((64*(values.dl-this.minima.dl)/(this.maxima.dl-this.minima.dl))+191)+")";
}

function BunnyhopinfoTabelle(bunnyhopinfo)
{
  this.kopf=bunnyhopinfo_tabelle_kopf;
  this.zeile=bunnyhopinfo_tabelle_zeile;
  this.colors=new Array("#D0FFD0","#D0D0FF","#D0D0FF","#D0FFD0","#FFD0D0","#FFD0D0","#D0FFD0","#D0D0FF","#D0D0FF","#D0FFD0");

  this.bunnyhopinfo=bunnyhopinfo;
  this.nice_real=this.bunnyhopinfo.nice_real;
  this.bunnyhop=this.bunnyhopinfo.bunnyhop;
  this.poi=this.bunnyhopinfo.poi;
  this.min_x=this.bunnyhopinfo.min_x;
  this.max_x=this.bunnyhopinfo.max_x;
  this.step_x=this.bunnyhopinfo.step_x;
  this.breite=this.bunnyhopinfo.breite;
  this.minima=this.bunnyhopinfo.minima;
  this.maxima=this.bunnyhopinfo.maxima;

  this.rtable=document.createElement("table");
  this.rtbody=document.createElement("tbody");
  this.rtable.appendChild(this.rtbody);

  this.point=0;
  this.t=0;

  var values=new Object();

  this.kopf();
  for (var x=this.min_x;x<=this.max_x;x+=this.step_x)
  {
    var doit=true;
    while ((this.point<this.poi.x.length)&&(x>=this.poi.x[this.point]))
    {
      if (x==this.poi.x[this.point])
      {
        doit=false;
      }
      this.bunnyhop.values(this.poi.x[this.point],values);
      this.zeile(values);
      this.kopf();
      this.point++;
      this.t=0;
      this.zeile(values);
      this.t++;
    }
    if (doit)
    {
      this.bunnyhop.values(x,values);
      this.zeile(values);
      this.t++;
    }
  }
  this.kopf();

  this.output=document.getElementById("output_tab");
  this.output.setAttribute("class","datenblatt");
  this.output.appendChild(this.rtable);
}

function bunnyhopinfo_tabelle()
{
  this._tabelle=new BunnyhopinfoTabelle(this);
}

function BunnyhopinfoDarstellung(bunnyhopinfo,what,where)
{
  this.bunnyhopinfo=bunnyhopinfo;
  this.what=what;
  this.where=where;
  this.bunnyhop=this.bunnyhopinfo.bunnyhop;
  this.min_x=this.bunnyhopinfo.min_x;
  this.max_x=this.bunnyhopinfo.max_x;
  this.breite=this.bunnyhopinfo.breite;
  this.minima=this.bunnyhopinfo.minima;
  this.maxima=this.bunnyhopinfo.maxima;
  this.senkrechten=this.bunnyhopinfo.senkrechten;
  this.koord_styler=this.bunnyhopinfo.koord_styler;
  this.hoehe=this.bunnyhopinfo["hoehe_"+this.where];

  this.koordsys_div=document.createElement("div");
  this.koordsys_div.setAttribute("class","tabellenblatt");
  this.koordsys_div.style.float="left";

  this.koordinatensystem=new Koordinatensystem(this.min_x,this.max_x,this.minima[this.what],this.maxima[this.what],this.breite,this.hoehe,10,10,10,10);
  for (var r in this.senkrechten)
  {
    this.koordinatensystem.senkrechte(r,this.koord_styler.style(this.senkrechten[r]));
  }
  this.koordinatensystem.funktion_f(this.bunnyhopinfo["bunny_"+this.what],-this.max_x,this.max_x,this.koord_styler.style("kurve_"+this.where));

  this.koordsys_div.appendChild(this.koordinatensystem.element);
  this.separator_div=document.createElement("div");
  this.separator_div.style.clear="both";

  this.output=document.getElementById("output_"+this.where);
  this.output.setAttribute("class","datenblatt");
  this.output.appendChild(this.koordsys_div);
  this.output.appendChild(this.separator_div);
}

function bunnyhopinfo_darstellung_h()
{
  this._darstellung_h=new BunnyhopinfoDarstellung(this,"f","h");
}

function bunnyhopinfo_darstellung_f()
{
  this._darstellung_f=new BunnyhopinfoDarstellung(this,"f","f");
}

function bunnyhopinfo_darstellung_f_()
{
  this._darstellung_f_=new BunnyhopinfoDarstellung(this,"f_","f_");
}

function bunnyhopinfo_darstellung_f__()
{
  this._darstellung_f__=new BunnyhopinfoDarstellung(this,"f__","f__");
}

function bunnyhopinfo_darstellung_dl()
{
  this._darstellung_dl=new BunnyhopinfoDarstellung(this,"dl","dl");
}

function bunnyhopinfo_darstellung()
{
  this.darstellung_h();
  this.darstellung_f();
  this.darstellung_f_();
  this.darstellung_f__();
  this.darstellung_dl();
}

function bunnyhopinfo_senkrechte(r,id)
{
  if (typeof(this.senkrechten[r])=="undefined")
  {
    this.senkrechten[r]=id;
  }
}

function bunnyhopinfo_koordstyle(id,style)
{
  if (typeof(this.koord_styler.styles[id])=="undefined")
  {
    this.koord_styler.styles[id]=style;
  }
}

function bunnyhopinfostyler_style(id)
{
  var rstyle="";
  if ((typeof(this.styles[id])!="undefined") && (this.styles[id]!=null))
  {
    rstyle=this.styles[id];
  }
  else
  {
    rstyle=this.defaultstyle;
  }
  return rstyle;
}

function BunnyhopInfoStyler(bunnyhopinfo)
{
  this.bunnyhopinfo=bunnyhopinfo;
  this.styles=new Object();
  this.style=bunnyhopinfostyler_style;
  this.defaultstyle="fill:none;stroke:rgb(192,192,192);stroke-width:1;";
}

function bunny_f(x)
{
  return this.bunnyhop.f(x);
}

function bunny_f_(x)
{
  return this.bunnyhop.f_(x);
}

function bunny_f__(x)
{
  return this.bunnyhop.f__(x);
}

function bunny_dl(x)
{
  return this.bunnyhop.dl(x);
}

function BunnyhopF(bunnyhop,f)
{
  this.bunnyhop=bunnyhop;
  this.f=f;
}

function pointsofinterest_add(x)
{
  this.points[x]=new Object();
  this.bunnyhop.values(x,this.points[x]);
}

function PointsOfInterest(bunnyhopinfo)
{
  this.bunnyhopinfo=bunnyhopinfo;
  this.bunnyhop=this.bunnyhopinfo.bunnyhop;
  this.points=new Object;
  this.add=pointsofinterest_add;
}

function bunnyhopinfo_cos_out()
{
  var bhi=this.upper.bunnyhopinfo;
  bhi.ergebnisfeld(this.name+"_a",this.upper.yplus+this.yplus+(this.xplus+this.upper.xplus)*this.gradient);
  bhi.ergebnisfeld(this.name+"_b",this.gradient);
  bhi.ergebnisfeld(this.name+"_c",this.amplitude);
  bhi.ergebnisfeld(this.name+"_d",(this.xplus+this.upper.xplus)*this.compression);
  bhi.ergebnisfeld(this.name+"_e",this.compression);
  bhi.ergebnisfeld(this.name+"_min_x",this.min_x-this.upper.xplus);
  bhi.ergebnisfeld(this.name+"_max_x",this.max_x-this.upper.xplus);
}

function bunnyhopinfo_line_out()
{
  var bhi=this.upper.bunnyhopinfo;
  bhi.ergebnisfeld(this.name+"_a",this.upper.yplus+this.yplus+this.gradient*this.upper.xplus)
  bhi.ergebnisfeld(this.name+"_b",this.gradient)
  bhi.ergebnisfeld(this.name+"_min_x",this.min_x-this.upper.xplus);
  bhi.ergebnisfeld(this.name+"_max_x",this.max_x-this.upper.xplus);
}

function bunnyhopinfo_ergebnisfeld(name,value)
{
  var rspan=document.getElementById(name);
  rspan.innerHTML=value;
}

function bunnyhopinfo_nice_real(v,factor,shift)
{
  var vf=""+Math.round(factor*Math.abs(v));
  while (vf.length<=shift)
  {
    vf="0"+vf;
  }
  var il=vf.length-shift;
  vf=vf.substr(0,il)+"."+vf.substr(il,shift);
  if (v<0) {
    vf="-"+vf;
  }
  return vf;
}

function BunnyhopInfo(bunnyhop)
{
  this.bunnyhop=bunnyhop;
  this.bunnyhop.bunnyhopinfo=this;
  this.nice_real=bunnyhopinfo_nice_real;
  this.ergebnisfeld=bunnyhopinfo_ergebnisfeld;
  this.bunnyhop.cos_left.out=bunnyhopinfo_cos_out;
  this.bunnyhop.cos_left.name="cos_l";
  this.bunnyhop.line_left.out=bunnyhopinfo_line_out;
  this.bunnyhop.line_left.name="line_l";
  this.bunnyhop.cos_middle.out=bunnyhopinfo_cos_out;
  this.bunnyhop.cos_middle.name="cos_m";
  this.bunnyhop.line_right.out=bunnyhopinfo_line_out;
  this.bunnyhop.line_right.name="line_r";
  this.bunnyhop.cos_right.out=bunnyhopinfo_cos_out;
  this.bunnyhop.cos_right.name="cos_r";
  this.x_left=this.bunnyhop.cos_left.min_x-this.bunnyhop.xplus;
  this.x_left_1=-this.bunnyhop.cos_left.xplus-this.bunnyhop.xplus;
  this.x_left_2=this.bunnyhop.cos_left.max_x-this.bunnyhop.xplus;
  this.x_left_3=this.bunnyhop.cos_middle.min_x-this.bunnyhop.xplus;
  this.x_middle=-this.bunnyhop.cos_middle.xplus-this.bunnyhop.xplus;
  this.x_right_1=this.bunnyhop.cos_middle.max_x-this.bunnyhop.xplus;
  this.x_right_2=this.bunnyhop.cos_right.min_x-this.bunnyhop.xplus;
  this.x_right_3=-this.bunnyhop.cos_right.xplus-this.bunnyhop.xplus;
  this.x_right=this.bunnyhop.cos_right.max_x-this.bunnyhop.xplus;
  this.min_x=1000*(Math.floor(this.x_left*0.001));
  this.max_x=1000*(Math.ceil(this.x_right*0.001));
  this.step_x=100;
  this.breite=0.05*(this.max_x-this.min_x);
  this.poi=new PointsOfInterest(this);
  this.poi.x=new Array(this.x_left,this.x_left_1,this.x_left_2,this.x_left_3,this.x_middle,this.x_right_1,this.x_right_2,this.x_right_3,this.x_right);
  for (var i=0;i<this.poi.x.length;i++)
  {
    this.poi.add(this.poi.x[i]);
  }
  this.minima=new Object();
  this.maxima=new Object();
  var poi_p=this.poi.points[-this.x_middle];
  this.minima.f=poi_p.f;
  this.minima.f_=poi_p.f_;
  this.minima.f__=poi_p.f__;
  this.minima.dl=poi_p.dl;
  this.maxima.f=poi_p.f;
  this.maxima.f_=poi_p.f_;
  this.maxima.f__=poi_p.f__;
  this.maxima.dl=poi_p.dl;
  for (var x in this.poi.points)
  {
    poi_p=this.poi.points[x];
    if (this.minima.f>poi_p.f)
      this.minima.f=poi_p.f;
    if (this.minima.f_>poi_p.f_)
      this.minima.f_=poi_p.f_;
    if (this.minima.f__>poi_p.f__)
      this.minima.f__=poi_p.f__;
    if (this.minima.dl>poi_p.dl)
      this.minima.dl=poi_p.dl;
    if (this.maxima.f<poi_p.f)
      this.maxima.f=poi_p.f;
    if (this.maxima.f_<poi_p.f_)
      this.maxima.f_=poi_p.f_;
    if (this.maxima.f__<poi_p.f__)
      this.maxima.f__=poi_p.f__;
    if (this.maxima.dl<poi_p.dl)
      this.maxima.dl=poi_p.dl;
  }
  this.hoehe_f=0.5*(this.maxima.f-this.minima.f);
  this.hoehe_h=0.1*this.hoehe_f;
  this.hoehe_f_=100;
  this.hoehe_f__=100;
  this.hoehe_dl=100;
  this.bunny_f=new BunnyhopF(bunnyhop,bunny_f);
  this.bunny_f_=new BunnyhopF(bunnyhop,bunny_f_);
  this.bunny_f__=new BunnyhopF(bunnyhop,bunny_f__);
  this.bunny_dl=new BunnyhopF(bunnyhop,bunny_dl);
  this.senkrechten=new Object();
  this.extrema=bunnyhopinfo_extrema;
  this.formeln=bunnyhopinfo_formeln;
  this.tabelle=bunnyhopinfo_tabelle;
  this.darstellung_h=bunnyhopinfo_darstellung_h;
  this.darstellung_f=bunnyhopinfo_darstellung_f;
  this.darstellung_f_=bunnyhopinfo_darstellung_f_;
  this.darstellung_f__=bunnyhopinfo_darstellung_f__;
  this.darstellung_dl=bunnyhopinfo_darstellung_dl;
  this.darstellung=bunnyhopinfo_darstellung;
  this.senkrechte=bunnyhopinfo_senkrechte;
  this.koordstyle=bunnyhopinfo_koordstyle;
  this.koord_styler=new BunnyhopInfoStyler(this);
}
